#!/bin/bash
#
# Install script for Delebgate of WebPerMoS
# 
# (C) 2003 Dr. Pankaj Jalote, Shashikant Kore 
#  Department of CSE, IIT Kanpur
#

INSTALL_PATH=/usr/local/webtest
ERROR=0

# If the installation directory does not exist, create it.
# If the installation directory exists, remove all the content
if [ ! -d $INSTALL_PATH ]; then
	echo "Creating directory $INSTALL_PATH		"
	mkdir $INSTALL_PATH
	ERROR=$?
	if [ $ERROR != 0 ]; then
		echo "Error in creating $INSTALL_PATH	"
		exit 1
	fi
else
	echo "Removing the contents of $INSTALL_PATH	"
	rm -f ${INSTALL_PATH}/*
fi

# Copy the installation and info files to appropriate location
echo "Copying installation files to $INSTALL_PATH"
cp -f *.jar $INSTALL_PATH
ERROR=$?
if [ $ERROR != 0 ]; then
	echo "Error in installation"
	exit 1
fi
cp -f README.txt $INSTALL_PATH
ERROR=$?
if [ $ERROR != 0 ]; then
	echo "Error in installation"
	exit 1
fi

# Find the path for java binary
OUTPUT=$(which java)

# Update the path for JVM in the Subsystem  control script 
cat permosd.in | sed -e "s#^JAVA_PATH.*#JAVA_PATH=${OUTPUT}#" > permosd.tmp
ERROR=$?
if [ $ERROR != 0 ]; then
	echo "Error in installation"
	exit 1
fi

# Add execute permission for the script
chmod +x permosd.tmp
ERROR=$?
if [ $ERROR != 0 ]; then
	echo "Error in installation"
	exit 1
fi

# Copy the script to proper location
echo "Copying sybsytem script "
cp -f permosd.tmp /etc/init.d/permosd
ERROR=$?
if [ $ERROR != 0 ]; then
	echo "Error in copying subsystem script "
	exit 1
fi

# Remove temporary file
rm -f permosd.tmp

# Add this subsystem 
echo "Adding the Delegate as daemon"
chkconfig --add permosd
ERROR=$?
if [ $ERROR != 0 ]; then
	echo "Error in installation"
	exit 1
fi

# Start the daemon
#echo "Starting daemon ...."
/etc/init.d/permosd start

echo "====================================="
echo "* Installation Successful!"
echo "*	Thank You for installing Delegate"
echo "* In case of any queries contact us"
echo "* smkore@cse.iitk.ac.in"
echo "====================================="

