/**.	This is the registration form displayed when the Delegate is started for the first time. 
 * 	Various information is read from the user and stored in the object. 
 */


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Form extends JFrame
{
	//dimensions of the panel
	final int WIDTH = 300;	
	final int HEIGHT = 400;

	// co-ordinates of the top-left corner of panel on screen
	final int TOPX = 200;
	final int TOPY = 200;

	String	name;//	= new String("");	// Name of the person hosting Delegate
	String	email	= new String("");	// Email address
	String	region	= new String("");	// Region of hosting Delegate
	String	city	= new String("");	// City of hosting Delegate
	String 	link	= new String("");	// Type of internet link available for Delegate
	String	os	= new String("");	// Operaing System on which Delegate is running
	String	priv	= new String("");	// Priveleges for Delegate - either of User/Admin/Dedicated
	boolean	usePr	= false;		// flag to indicate use of proxy - by default no proxy

	// following Attributes are valid only if proxy is being used
	String	proxyURL= new String("");	// Proxy URL	
	int 	proxyPort;			// Proxy Port
	String	proxyUsr= new String("");	// User name for the proxy
	String 	proxyPass= new String("");	// Password for proxy
	String	noProxy	= new String("");	// Proxy should not be used for this url

	// following are the synchronization variables 
	boolean	done	= false;		// flag to indicate the information reading status.
						// true indicates, the info has been read 

	// flag indicating the wait status of some object for the completion of reading info
	boolean isWaiting = false;

	Form()
	{
		super("Registration Detail");
		// Two Panels (One for input & Other for Buttons)

		JPanel inputPanel = new JPanel();	
		JPanel buttonPanel = new JPanel();

		//All Labels

		final JLabel nameLabel = new JLabel("Name : ",SwingConstants.RIGHT);
		final JLabel emailLabel = new JLabel("E-Mail : ",SwingConstants.RIGHT);
		final JLabel regionLabel = new JLabel("Region : ",SwingConstants.RIGHT);
		final JLabel cityLabel = new JLabel("City : ",SwingConstants.RIGHT);
		final JLabel inetLinkLabel = new JLabel("Internet Link : ",SwingConstants.RIGHT);
		final JLabel osLabel = new JLabel("Operating System : ",SwingConstants.RIGHT);
		final JLabel privilegeLabel = new JLabel("Privilege : ",SwingConstants.RIGHT);
		final JLabel httpProxyLabel = new JLabel("HTTP Proxy : ",SwingConstants.RIGHT);
		final JLabel proxyURLLabel = new JLabel("Proxy URL : ",SwingConstants.RIGHT);
		final JLabel proxyPortLabel = new JLabel("Proxy Port : ",SwingConstants.RIGHT);
		final JLabel proxyUserLabel = new JLabel("Proxy User : ",SwingConstants.RIGHT);
		final JLabel proxyPasswdLabel = new JLabel("Proxy Password : ",SwingConstants.RIGHT);
		final JLabel noProxyLabel = new JLabel("No Proxy : ",SwingConstants.RIGHT);


		//All Buttons

		JButton submitButton = new JButton("Submit");
		JButton clearButton = new JButton("Clear");

		//All String array for combo boxes.

		final	String[] regionList = {"Africa", "Asia", "Asia Pacific", "Europe", "India", "Latin America", "Middle East", "North America" };
		final	String[] regionVal = {"Africa", "Asia", "AsiaPac", "Europe", "India", "LatinAm", "MiddleE", "NAmerica" };
		
		// various types of internet links
		// this specifies the items to be displayed in the form
		final	String[] inetLinkList = {"Cable Modem","Dial Up 33kbps","Dial Up 56kbps","DSL", "ISDN", "T1", "T2","Wireless" };

		// this spcifies the corresponding values for above items
		final	String[] inetVal= {"Cable","D33","D56","DSL", "ISDN", "T1", "T2","WL"};
		
		final	String[] osList = {"Linux", "Unix Clones", "Windows NT/2K/XP", "Windows 9x"};
		final	String[] osVal 	= {"Linux", "Unix", "Win2K", "Win9x"};

		final	String[] privilegeList	= {"Admin", "Dedicated","User" };
		final	String[] privVal	= {"Adm", "Ddc","Usr" };

		//All Textboxes & Combos

		final JTextField nameField = new JTextField();
		final JTextField emailField = new JTextField();
		final JTextField cityField = new JTextField();
		final JTextField proxyURLField = new JTextField();
		final JTextField proxyPortField = new JTextField();
		final JTextField proxyUserField = new JTextField();
		final JPasswordField proxyPasswdField = new JPasswordField();
		final JTextField noProxyField = new JTextField();
			
		final JComboBox regionBox = new JComboBox(regionList);	
		final JComboBox inetLinkBox = new JComboBox(inetLinkList);	
		final JComboBox osBox = new JComboBox(osList);	
		final JComboBox privilegeBox = new JComboBox(privilegeList);	

		JPanel httpProxyPanel = new JPanel();

		final JRadioButton httpProxyYesButton = new JRadioButton("Yes",true);
		final JRadioButton httpProxyNoButton = new JRadioButton("No");

		ButtonGroup group = new ButtonGroup();
		group.add(httpProxyYesButton);
		group.add(httpProxyNoButton);

		//------------------------------------------------------------
		
		httpProxyPanel.add(httpProxyYesButton);
		httpProxyPanel.add(httpProxyNoButton);
		
		inputPanel.setLayout(new GridLayout(0,2,5,5));
					
		inputPanel.add(nameLabel);
		inputPanel.add(nameField);
		inputPanel.add(emailLabel);
		inputPanel.add(emailField);
		inputPanel.add(regionLabel);
		inputPanel.add(regionBox);
		inputPanel.add(cityLabel);
		inputPanel.add(cityField);
		inputPanel.add(inetLinkLabel);
		inputPanel.add(inetLinkBox);
		inputPanel.add(osLabel);
		inputPanel.add(osBox);
		inputPanel.add(privilegeLabel);
		inputPanel.add(privilegeBox);
		inputPanel.add(httpProxyLabel);
		inputPanel.add(httpProxyPanel);
		inputPanel.add(proxyURLLabel);
		inputPanel.add(proxyURLField);
		inputPanel.add(proxyPortLabel);
		inputPanel.add(proxyPortField);
		inputPanel.add(proxyUserLabel);
		inputPanel.add(proxyUserField);
		inputPanel.add(proxyPasswdLabel);
		inputPanel.add(proxyPasswdField);
		inputPanel.add(noProxyLabel);
		inputPanel.add(noProxyField);

		buttonPanel.add(submitButton);
		buttonPanel.add(clearButton);
		
		Container cpane = getContentPane();

		cpane.add(inputPanel,"Center");
		cpane.add(buttonPanel,"South");				

		//------------------------------------------------------------		
		//Add Events
		addWindowListener(new WindowAdapter()
					{
						public void windowClosing(WindowEvent e)
						{
							System.exit(0);
						}
					});

		httpProxyYesButton.addActionListener(new ActionListener()
					{
						public void actionPerformed(ActionEvent e)
						{
							if(httpProxyYesButton.isSelected())
							{
								proxyURLLabel.setEnabled(true);
								proxyPortLabel.setEnabled(true);
								proxyUserLabel.setEnabled(true);
								proxyPasswdLabel.setEnabled(true);
								noProxyLabel.setEnabled(true);
								proxyURLField.setEnabled(true);
								proxyPortField.setEnabled(true);
								proxyUserField.setEnabled(true);
								proxyPasswdField.setEnabled(true);
								noProxyField.setEnabled(true);
							}
						}
					});

		httpProxyNoButton.addActionListener(new ActionListener()
					{
						public void actionPerformed(ActionEvent e)
						{
							if(httpProxyNoButton.isSelected())
							{
								proxyURLLabel.setEnabled(false);
								proxyPortLabel.setEnabled(false);
								proxyUserLabel.setEnabled(false);
								proxyPasswdLabel.setEnabled(false);
								noProxyLabel.setEnabled(false);
								proxyURLField.setEnabled(false);
								proxyPortField.setEnabled(false);
								proxyUserField.setEnabled(false);
								proxyPasswdField.setEnabled(false);
								noProxyField.setEnabled(false);
							}
						}
					});

		submitButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				String errorMessage="";

				if(nameField.getText().trim().equals("")) errorMessage = "Name Field Is Empty";
				else if(emailField.getText().trim().equals("")) errorMessage = "E-Mail Field Is Empty";
				else if(cityField.getText().trim().equals("")) errorMessage = "City Field Is Empty";			
				else if(httpProxyYesButton.isSelected())
				{
					if(proxyURLField.getText().trim().equals("")) errorMessage ="Enter Proxy URL";
					else if(proxyPortField.getText().trim().equals("")) errorMessage = "Enter Port Number";
		// proxy user name and password are not checked as proxy can configured to be used without authorization

			//		else if(proxyUserField.getText().trim().equals("")) errorMessage = "Enter Proxy User";
			//	 	else if(new String(proxyPasswdField.getPassword()).trim().equals("")) errorMessage = "Enter Password";
				};

				if(!errorMessage.equals("")) JOptionPane.showMessageDialog(getParent(),errorMessage,"Error",JOptionPane.ERROR_MESSAGE);
				else
				{
					name	= nameField.getText().trim();
                                        email	= emailField.getText().trim();
                                        region	= regionVal[regionBox.getSelectedIndex()];
                                        city	= cityField.getText().trim();
                                        link	= inetVal[inetLinkBox.getSelectedIndex()];
                                        os	= osVal[osBox.getSelectedIndex()];	
                                        priv	= privVal[privilegeBox.getSelectedIndex()];
                                        usePr	= httpProxyYesButton.isSelected();


					if (httpProxyYesButton.isSelected())
					{
						proxyURL = proxyURLField.getText().trim();
						proxyPort= Integer.parseInt(proxyPortField.getText().trim());
						proxyUsr = proxyUserField.getText().trim();
						proxyPass= new String(proxyPasswdField.getPassword()).trim();
						noProxy	 = noProxyField.getText().trim();
					}
					
					setVisible(false);
					gotInfo();	// set the flag to indicate that information has been read
				}
			}
		});


		clearButton.addActionListener(new ActionListener()
					{
						public void actionPerformed(ActionEvent e)
						{
							nameField.setText("");
							emailField.setText("");
							regionBox.setSelectedIndex(0);
							cityField.setText("");
							inetLinkBox.setSelectedIndex(0);
							osBox.setSelectedIndex(0);
							privilegeBox.setSelectedIndex(0);
							proxyURLField.setText("");
							proxyPortField.setText("");
							proxyUserField.setText("");
							proxyPasswdField.setText("");
						}			
					});

		// setSize(WIDTH,HEIGHT);
		setBounds(TOPX,TOPY,WIDTH,HEIGHT );
		setVisible(true);
	}	

	synchronized public void waitForInfo()
	{
		while (!done)	// while info has not been read, wait
		{
			try
			{
				isWaiting = true;	// set waiting flag 
				wait();
			}
			catch (InterruptedException e)
			{

			}
		}
		return;
	}

	synchronized private void gotInfo()
	{	
		done = true;	// got all the info
		if (isWaiting)	// if somebody is waiting, notify
			notify();	
	}

}

