/**.
 *  This class will be used to put the results of transaction in a specific format. 
 * The formatting is needed because the various fields in the result of transaction will be uploaded seperately. 
 */

import java.util.*;

class FormatUploadRes
{
	String		JobID;
	int		NumStep;
	String		Stime;		// start time of transaction. useful while marking the result as  "uploaded".
	String		jRes;		// result for the transaction
	ArrayList	pgRes;		// result for a single page - high level details 
	ArrayList	pgDetailRes;	// result for page which includes the detailed result of each component of page.

	FormatUploadRes()
	{
		JobID = new String("");
		jRes  = new String("");	
		Stime = new String("");
		pgRes = new ArrayList();
		pgDetailRes = new ArrayList();
	}
	
/** Add the results of transaction 
 *  The parameter is the string containing the results for transaction. 
 */ 
	public void addT(String j)
	{
		jRes = j;
	}

/** Add the results of a page 
 * The string containing the results for page is added to the list of page results	
 */ 
	public void addP(String p)
	{
		pgRes.add(p);
	}

/** Add the results of components of page 
 * The string containing the results for components is added to the list of detailed page results
 */ 
	public void addD(String d)
	{
		pgDetailRes.add(d);
	}

	public void setJobInfo(String j, int n)
	{
		JobID = j;
		NumStep = n;
	}

/** 
 *  Give JobID and Start time of transaction. 
 *  This is used when the result is uploaded successfully and it needs to be marked as "Uploaded".
 */
	public void getJinfo(String jid, String stime) // DID NOT WORK
	{	
		jid = this.JobID;
		stime = this.Stime;
	}

	public String toString()
	{
		String 	str	= new String("");
		String	tmp	= new String("");
		String 	nl	= new String("\n");
	
		str	+= JobID + nl ;
		str	+= NumStep+nl;
		str	+= Stime +nl;	
		str	+= jRes+nl;	
		str	+= pgRes.size()+nl;	    
		str	+= pgDetailRes.size()+nl;

		return str;
	}
}
