
/**.
 *	The high-level information for a job is made available from this class
 *	This information is used for futher processing and scheduling of various jobs.
 */
import java.util.*;

class JobInfo 
{
	String	JobID;		// JobID
	String 	Jtype;		// Job type - currenly only TRA (stands for transaction) is supported
	Date	FromDate;	// Start Date for the transaction
	Date	ToDate;		// End Date for the transaction
	int	StartTime;	// Start Time for the transaction on each day
	int	EndTime;	// End Time for the transaction on each day
	int	NumSample;	// Total Number of Samples during the stipulated hours of each day
	int 	NumSteps;	// Total number of steps in the transaction

	// following variables are used in scheduling of the jobs 
	
	Date	NextSch;	// Next sample will be taken at this time
	Date	ActualNext;	// The job will actually start at this time. There is difference between earlier time and this.
	int 	interval;	// time interval between two samples (in minutes) - this is derived attribute

	JobInfo(String jid, String jtype, Date fd, Date td, int  stime, int  etime, int  numsamp, int  numsteps )
	{
		JobID 		= new String(jid);
		Jtype 		= new String(jtype);
		FromDate 	= new Date() ;
		FromDate	= fd;
		ToDate		= new Date();
		ToDate		= td; 
		StartTime	= stime;
		EndTime		= etime;
		NumSample	= numsamp;
		NumSteps	= numsteps;

		NextSch		= new Date();	//initialize with current date
		ActualNext	= new Date();
		interval	= 0;		//initialize with zero
	}

	JobInfo()
	{
		JobID = new String("");
		Jtype = new String("");
		FromDate = new Date();
		ToDate = new Date();

	}

	public String toString()
	{
		String j = new String("");
		
		j += "JobInfo	: *****\n";
		j += "JobInfo	: JobID	"+ JobID + "\n";
		j += "JobInfo	: From  " + FromDate +"\n";
		j += "JobInfo	: To    " +  ToDate +"\n";
		j += "JobInfo	: \n";
		return j;
	}
}
