
/**.
 * This class specifies the number of threads currently active. 
 * There is a limit on the maximum number of threads that can be created simultaneously.
 * At a time there will not be more than 7 threads (excluding main) running. This limit is same as that of Mozilla.
 * 
 */

import java.lang.*;
import java.io.*;
import java.util.*;

class NumThread
{
	private  int 	MaxThread = 7;		// Maximum number of threads that can be created
	private  int 	num= 7; 		// number of new threads that can be created, initialised with MaxThread 
	private  boolean 	exitAll = false;	// waiting for all threads to exit
	private  boolean 	exitAny = false;	// waiting for any threads to exit
	
	NumThread()
	{	
	}

	synchronized  int getMax()
	{	return MaxThread; 	}

	synchronized  int curVal()  // the number of threads that can be created 
	{	return num;	}  


	// when a thread exits, the number of threads that can be created is increased
	synchronized  void increase()  
	{	num+= 1;	}
	
	// when a new thread is created, the number of threads that can be created is decremented
	synchronized  void decrease()
	{	num -= 1;	}

	synchronized  void waitAllExit(boolean val)
	{	exitAll = val;	}

	synchronized  void waitAnyExit(boolean val)
	{	exitAny = val;	}


	synchronized  boolean getAnyExit()
	{	return exitAny;	}

	
	synchronized  boolean getAllExit()
	{	return exitAll;	}

	synchronized   void  exitThread()
	{
		num += 1;	
		if ( (num == MaxThread)	&&  exitAll)
		{
			exitAll = false;
			notify();
			return;
		}
		if (exitAny)
		{	
			exitAny = false;
			notify(); 
			return; 
		}
	}

	synchronized void waitExitThread()
	{
		try
		{
			wait();
		}
		catch (InterruptedException e)
		{
			System.out.println(" ");
		}
		return;
	}

	synchronized void  exitPage()
	{
		if (num == MaxThread)
			return; 
		else
		{
			try
			{
				exitAll = true;
				wait();
			}
			catch (InterruptedException e)
			{
				System.out.println(" " + e);
			}
			return;
		}
	}
}


