
/**.
 * This is a thread for uploading results of various transactions.  
 * The results are submitted to Reporting Centre
 *
 */
import java.io.*;
import java.util.*;
import java.lang.*;

class UploadResult extends Thread
{
	Thread		t;	// current thread

	UploadResult()
	{
		t = new Thread(this);
		t.start();	
	}
	public void run()
	{

		String pgParam 	= new String("");	// page parameters
		String pgParVal	= new String("");	// values for respective page parameters
		String		delim = new String("|");	// delimeter to seperate parameters
		int 		i=0;
		PageDetails	pgDet; 
		PageResult 	pgRes;
		String 		fName = new String("");

		// purge all the uploaded results from result file		
		System.out.println("UploadResult	: Purging the uploaded results  ");
		Result.purgeUploaded();	

		while(true)
		{
			FormatUploadRes r = new FormatUploadRes();
			Result.getResult(r);

			// Flag to indicate the status of uploading the result
			// true = success, false=failure
			boolean	successUp = true ; 

			// no job for uploading, sleep for 30 minutes 
			if (r.JobID.length() < 2) // JobID length is used to check the validity of result
			{
				System.out.println("UploadResult	: Purging the uploaded results  ");
				Result.purgeUploaded();	// purge all the uploaded results from result file
				try
				{
					System.out.println("No Job For uploading. Sleeping for 30 minutes ");
					Thread.sleep(1800000); //sleep for 1800 seconds (30 minutes)
					continue;
				}
				catch (InterruptedException e)
				{
					System.out.println("UploadResult : Interrupted " + e);
					continue;
				}
			}// end if 

		//	System.out.println("Uploading Result of "+ r.toString());
		//	System.out.println("Uploading Result of "+ r.JobID);

			pgParam	= new String("");	// page parameters
			pgParVal= new String("");	// values for respective page parameters

			pgParam += "JobID"+delim+"Numstep"+delim+"DelID"+delim+"Tres"+delim;
			pgParVal += r.JobID+delim+r.NumStep+delim+Global.getDelID()+delim+r.jRes+delim;

			i=0;

			while(i < r.pgRes.size())
			{
				String pg = new String("Page"+(i+1));	// this is the parameter of the page
				String pd = new String("PageD"+(i+1));	// this is the parameter of the page
				String s1 = (String) r.pgRes.get(i);
				String s2 = (String) r.pgDetailRes.get(i);

				pgParam += pg + delim + pd + delim;
				pgParVal += s1+ delim + s2 + delim;

				i++;
			}

			pgDet = Global.getUploadDetail();
			pgRes = new PageResult();

			pgDet.setPgParam(pgParam, pgParVal,"" );
		/*
			System.out.println("UploadResult	: Parameters \n" + pgParam); 
			System.out.println("UploadResult	: Values \n" + pgParVal); 
		*/
			Page p = new Page(pgDet, pgRes);

			try
			{
				p.t.join();
			}
			catch (InterruptedException e)
			{	
				System.out.println("UploadResult : Thread Interrupted");
			}
			fName = pgRes.pgFile;

			System.out.println("UploadResult : File "+ fName);
			try
			{
				BufferedReader input = new BufferedReader(new FileReader(fName));
				String s = new String("");

				boolean done = false; 	// flag to indicate the result has been uploaded 

				while(((s=input.readLine())!= null) && !done) 
				{
					if (s.startsWith("OK"))
					{
						// mark this transaction result as uploaded
						String jid = new String(r.JobID); 
						String stime = new String(r.Stime);
						Result.markUploaded(jid, stime);
						done = true;
					}
				}
				input.close();
			}
			catch(IOException e)
			{
				System.out.println("UploadResult	: IOException \n"+e);
				successUp = false;
			}

			// delete the downloaded file 
			pgRes.delPageFile();

			try
			{
				// in case of success, sleep for 60 seconds
				// else sleep for 15 minutes
				if (successUp == true)
				{
					System.out.println("UploadResult	: Sleeping for 60 seconds ");
					Thread.sleep(60000); //sleep for 60 seconds
				}
				else
				{
					System.out.println("UploadResult	: Sleeping for 15 minutes ");
					Thread.sleep(900000); //sleep for 900 seconds = 15 minutes
				}
			}
			catch (InterruptedException e)
			{

			}	
		} // end while true
	} // end run
}

