
/**.	This class does some boot-up work for delegate.
 *	Parameters  for proxy server are stored in a configuration file (ProxyParam.conf) 
 *	Intitially, this configuration file does not exist. 
 *	While the Delegate starts for the first time, the configuration file is created
 *	Once configuration file is created, this class does not have any function
 *	Any line startin with a '#' is considered to be comment and is ignored
 *	*** THE PROXY IS ASSUMED TO BE HTTP PROXY
 */

import java.io.File;
import java.io.FileWriter;
import java.io.*;
import java.util.*;

class ConfigProxy
{

	final   String BASE_DIR_CONF = new String("C:/PerMoS/conf/");
	final String	prFile = new String(BASE_DIR_CONF + "proxy.conf");

	/**.	
	 *	constructor accpets following parameters
	 *	"use" - using proxy - value (YES/NO)
	 *	"url" - url of the proxy
	 *	"user" - proxy user name
	 *	"pass" - proxy password
	 *	"noproxy" - the url which should be accessed without proxy (currently only one url can be given)
	 *
	 */

	ConfigProxy(String use, String url, int port, String user, String pass, String noproxy)
	{
		config(use, url, port, user, pass, noproxy);
		return;
	}

	// following constructor is invoked if NO proxy is used
	ConfigProxy(String use)
	{
		if (use.equalsIgnoreCase("NO"))
			config(use,"",0,"","","");
		return;
	}

	private void config(String use, String url, int port, String user, String pass, String noproxy)
	{
		// create  configuration file
		File f = new File(prFile);

	/*	if (f.exists() == true)	// if file exits, return
			return;
	 */
	
		System.out.println("Creating proxy configuration file");

		if (f.exists() == false)	// if file does not exit, create a new one.
		{
			try
			{
				f.createNewFile();
			}
			catch (Exception e)
			{
				System.out.println(" Error in creating file : ConfigProxy.java " + e );
			}
		}

		// file created, now update the parameters
		try
		{

			BufferedWriter 	out = new BufferedWriter(new FileWriter(prFile));

			out.write("###	This file contains proxy configuration  ###");
			out.newLine();
			out.write("###	Format of the file is <Parameter> = <value> (spaces acting as seperator) ###");
			out.newLine();
			
			out.write("### UseProxy : Using HTTP proxy? YES/NO	###");
			out.newLine();	
			out.write("### If UseProxy is YES, then remaining parameters must be specified ###");
			out.newLine();	
			out.write("UseProxy =  " + use );
			out.newLine();	
			out.write("### ProxyURL : Proxy URL/IP address ###");
			out.newLine();
			out.write("ProxyURL =  "+ url);
			out.newLine();	
			out.write("### ProxyPort : Port number to used to connect to proxy  ###");
			out.newLine();
			if (port>0) // write port number only if it is greater than 0
				out.write("ProxyPort =  "+ port);
			else
				out.write("ProxyPort =  ");
			out.newLine();	
			out.write("### Proxy Authentication parameters ###");
			out.newLine();
			out.write("### ProxyUser : Proxy User Name  ###");
			out.newLine();
			out.write("ProxyUser =  "+ user);
			out.newLine();
			out.write("### ProxyPass : Proxy Password  ###");
			out.newLine();
			out.write("ProxyPass =  "+ pass);
			out.newLine();	
			out.write("### NoProxy : Don't use proxy for following url ###");
			out.newLine();
			out.write("NoProxy =  "+ noproxy);
			out.newLine();	

			out.flush();
			out.close();
			System.out.println("Creating proxy configuration file....Done");
		}
		catch (Exception e)
		{		
			System.out.println("ConfigProxy : Unable to write to proxy.conf");
		}
		return;
	}
}
