/* 
 * The results for the component of a page are specified with an object of ComponentResult class.
 * All the parameters are measured/noted during fetching the component are stored in the object. 
 * 
 */

class ComponentResult
{
	String	cmpURL;		// URL of the component
	String	contentType;	// Content type of the component - img/txt/binary
	int	connectDelay;	// Connect Delay for the component 
	int	sendReqDelay;	// Time Required to send the request to server 

	// First Byte Latency : This is delay between completion of request and receiving first chunk of bytes from server
	int	FBLatency;	

	// Complete component download time - right from establishing connection to receiving last byte of the component
	int 	cmpDL;		

	int	cSize;		// Size of the component in number of bytes
	int	headerSize;	// Size of the HTTP header associated with the component

	
	boolean	cmpSuccess;	// Flag to indicate whether page was fetched successfully - true indicates success
	String	failReason;	// If test has failed, then the string gives the reason for failure


	ComponentResult()
	{
		cmpURL 		= new String("");
		contentType 	= new String("");

		// initialize all the parameters to zero
		connectDelay	= 0;
		sendReqDelay	= 0;
		FBLatency	= 0;     
		cmpDL		= 0;	     
		cSize		= 0;	   
		headerSize	= 0;
           
  		cmpSuccess	= true ;
                failReason	= new String("") ;
	}


/**. 	If failure occurs, then this method is called with the reason for failure
 *	The reason might be http error code (which is 4XX or 5XX) or
 *	The reason might be string indicating various exceptions such as - ConnectException, NoRouteToHostException, etc.
 *
 */
	public void setFailure(String reason)
	{
		cmpSuccess	= false ; 	// failure occurred
		failReason	= reason;	// failure reason string
	}

	public String toString()
	{
		String	st = new String("");
		
		st += "Component URL 	: " + cmpURL + "\n";		
                st += "Component Content: " + contentType+ "\n";	
                st += "Component Delay	: " + cmpDL+ "\n";		
                st += "Component Size	: " + cSize+ "\n";		

		return st;
                                                 
	}                                        
                                 	
}                                	

