
/* 
 * This class contains global variables used 
 * The information about proxy server is stored in this class. 
 *
 */

import java.io.*;
import java.util.*;
import java.text.*;

public class Global
{

	static boolean 	useProxy;	// flag indicating use of proxy. true = proxy server used
	static String	proxyURL;	// Proxy URL
	static int	proxyPort;	// Port number to be used for connecting to proxy
private	static String 	proxyUser;	// Proxy User name
private	static String	proxyPass;	// Proxy Password
	static String	authUser;	// proxy authorization string. this is base64 encoding of <username>:<password>
	static String 	noProxy	;	// Do not use proxy for this address

	// The base directory for all the configuration files and the files which will be created during testing  
	final	static String	BASE_DIR_CONF	= new String("C:/PerMoS/conf/");
	final	static String	BASE_DIR_LOG	= new String("C:/PerMoS/logs/");

	static String	resFile = new String("");	// the file for stroring transaction result	
	static String	profileFile = new String("");	// the file for stroring job profile
	static String 	delID	= new String(""); 	// Delegate ID

	// URL for Registration of Delegate
	static String 	regURL = new String("");
	static String 	regMethod = new String("");
	static String 	regVers = new String("");
	static int	regPort ;

	// URL for uploading the result. right now, it is hardcoded. 
	static String 	upResURL = new String("");
	static String 	upResMethod = new String("");
	static String 	upResVers = new String("");
	static int	upResPort ;

	// URL for sending  Alive message alongwith other parameters. 
	static String 	aliveURL = new String("");
	static String 	aliveMethod = new String("");
	static String 	aliveVers = new String("");
	static int	alivePort ;


	// URL for downloading job profile for a particular jobid  
	static String 	jobdlURL = new String("");
	static String 	jobdlMethod = new String("");
	static String 	jobdlVers = new String("");
	static int	jobdlPort ;

private	static final String LOOKUP[] =	{ "ResFile", "ProfileFile","DelID", 
					"UpResURL", "UpResPort", "UpResVers", "UpResMethod", 
					"AlivePort", "AliveURL", "AliveVers","AliveMethod", 
					"JobDLURL", "JobDLPort", "JobDLVers", "JobDLMethod", 
					"UseProxy", "ProxyURL", "ProxyPort", "ProxyUser", "ProxyPass", "NoProxy",
					"RegURL", "RegPort", "RegVers", "RegMethod"
					 };

private	static final int ResFile = 0, ProfileFile = 1,DelID = 2, UpResURL= 3, UpResPort= 4, UpResVers = 5, UpResMethod = 6;
private	static final int AlivePort =7, AliveURL=8, AliveVers=9, AliveMethod=10, JobDLURL=11, JobDLPort=12, JobDLVers=13, JobDLMethod =14; 
private	static final int UseProxy=15, ProxyURL=16 , ProxyPort=17, ProxyUser=18, ProxyPass=19, NoProxy=20;
private static final int RegURL=21, RegPort=22, RegVers=23, RegMethod=24;

static	{
		final String rcpFile	= new String(BASE_DIR_CONF + "rcparam.conf");// File having Reporting Centere Paremeters
		final String pcFile	= new String(BASE_DIR_CONF + "proxy.conf");	// File having Proxy Configuration

		try 
		{
			System.out.println("Global	: Reading Reporting Center Parameters...");

			// **** Read Reporting Centre parameters from file  and initialize the variables
			// rcpFile contains name of the Reporting Centre Configuration file 
			BufferedReader input = new BufferedReader(new FileReader(rcpFile)); 
			String s = new String();

			while((s=input.readLine())!= null) 
			{
				StringTokenizer st = new StringTokenizer(s);	// creates token of the string

				String		par = st.nextToken();		// get the first token which is the parameter name
				String		eq = st.nextToken();		// second token is "=" sign
				
				String		val = new String("");

				if (st.hasMoreTokens())
				{
					val = st.nextToken();		// third token is the value of the parmeter
				}
				
				if (par.startsWith("#"))			// a # indicates comment - hence ignore
					continue;

				// according to the parameter, initialize respective variable
				switch (lookupIndex(par))	
				{
					case ResFile 		:
						resFile	= BASE_DIR_CONF + val;	break;

					case ProfileFile 	:
						profileFile = BASE_DIR_CONF +  val; break;

					case DelID 		:
						delID = val; break;

					case UpResURL		:
						upResURL = val; break;

					case UpResPort		:
						upResPort = Integer.parseInt(val); break;

					case UpResVers		:
						upResVers = val; break;

					case UpResMethod	:
						upResMethod = val; break;

					case AlivePort		:	
						alivePort = Integer.parseInt(val); break;

					case AliveURL		:
						aliveURL = val; break;

					case AliveVers		:
						aliveVers = val; break;

					case AliveMethod	:
						aliveMethod = val; break;

					case JobDLURL		:
						jobdlURL = val; break;

					case JobDLPort		:
						jobdlPort = Integer.parseInt(val); break;

					case JobDLVers		:
						jobdlVers = val; break;

					case JobDLMethod 	:
						jobdlMethod = val; break;

					case RegURL		:
						regURL = val; break;

					case RegPort		:
						regPort = Integer.parseInt(val); break;

					case RegVers		:
						regVers = val; break;

					case RegMethod 	:
						regMethod = val; break;

					default : 
						System.out.println("Global	: Unknown Parameter in rcparam.conf "); break;

				} // end switch
			}// end while s = readline

			// reading Reporting Center parameters done!
			input.close();


			System.out.println("Global	: Reading Proxy Cofiguration Parameters...");


			// **** Read proxy configuration parameters from file  and initialize the variables

			// pcFile contains name of the Proxy Configuration file 
			input = new BufferedReader(new FileReader(pcFile));
			s = new String();
			boolean	usingpr = false; // flag to indicate that proxy use is "NO". it will be changed after reading config file

			while((s=input.readLine())!= null) 
			{
				StringTokenizer st = new StringTokenizer(s);	// creates token of the string

				String		par = st.nextToken();		// get the first token which is the parameter name
				String		eq = st.nextToken();		// second token is "=" sign
				String		val = new String("");

				if (st.hasMoreTokens())			// if it has more tokens
				{
					val = st.nextToken();		// third token is the value of the parmeter
				}

				if (par.startsWith("#"))		// a # indicates comment - hence ignore
					continue;

				// according to the parameter, initialize respective variable
				switch (lookupIndex(par))	
				{

					case UseProxy	:
						if (val.equalsIgnoreCase("YES"))
						{	useProxy = true; usingpr = true; }
						if (val.equalsIgnoreCase("NO"))
						{	useProxy = false; usingpr = false;}
							break;	


					// following parameters will be valid only if useProxy == true
					case ProxyURL 	:
						if (usingpr)
							proxyURL = val; 
						else 	
							proxyURL = new String("");
						break;	

					case ProxyPort 	:
						if (usingpr)
							proxyPort = Integer.parseInt(val); 
						else 
							proxyPort = 0;
						break;

					// it may happen that proxy is used without any authentication.
					// in that case proxy user and password will be empty.
					case ProxyUser	: 
						if (usingpr)
							proxyUser = val; 
						else 
							proxyUser = new String(""); 
						break;	

					case ProxyPass	:
						if (usingpr)
							proxyPass = val; 
						else 
							proxyPass = new String(""); 
						break;

					case NoProxy	:
						if (usingpr)
							noProxy = getHost(val);
						else 
							noProxy = new String(""); 
						break;
	
					default :
						System.out.println("Unknown Parameter in proxy.conf "); break;

				}// end switch
			}// end while s = readline

			// reading Proxy configuration done!
			input.close();


                        // if proxy user name is not empty, create authorization string, otherwise it will be empty
			if (proxyUser.length() > 0)
				authUser = Base64.encode(proxyUser+":"+proxyPass);
			else
				authUser = new String("");

		}// end try
		catch(IOException e) 
		{
			System.out.println("Global: Error in reading configuration files "+e);
		}

		// Create result file for storing transaction results 
		File f = new File(resFile);

		if (f.exists() == false)	// if file does not exit, create a new one.
		{
			try
			{
				f.createNewFile();
			}
			catch (Exception e)
			{
				System.out.println(" Error in creating file : ConfigDelegate.java " + e );
			}
		}

		// Create file for storing Profiles for various transactions
		f = new File(profileFile);

		if (f.exists() == false)	// if file does not exit, create a new one.
		{
			try
			{
				f.createNewFile();
			}
			catch (Exception e)
			{
				System.out.println(" Error in creating file : ConfigDelegate.java " + e );
			}
		}
	}

/* 	getHost returns the string of hostname from given url 
 *	eg. if the input url is "http://www.mysite.com/" then 
 *	this method returns the host part of it i.e. "www.mysite.com"
 *
 */
	private static String getHost(String url)
	{
		String 	t = url;
		String	ret = new String("");

		int a = t.indexOf('/');
		int b = t.indexOf('/',a+1);
		int c = t.indexOf('/',b+1);	

		if (c < 0)
		{
			ret = t.substring(b+1);
		}
		else
		{
			ret = t.substring(b+1,c);
		}
		return ret;
	}

	public static void showvar()
	{
		System.out.println("Upload "+ upResURL);
		System.out.println("Upload "+ upResPort);
		System.out.println("Upload "+ upResMethod);
		System.out.println("Upload "+ upResVers);
		System.out.println("*****");
		System.out.println("Proxy "+ useProxy);
		System.out.println("Proxy "+ proxyUser);
		System.out.println("Proxy "+ proxyPass);
		System.out.println("Proxy "+ proxyPort);
		System.out.println("Proxy "+ proxyURL);
		System.out.println("Proxy "+ authUser);

	}

	private static int lookupIndex(String s)
	{
		for (int i=0; i< LOOKUP.length; i++)
		{
			if (s.equals(LOOKUP[i]))
				return i;
		}
		return -1;
	}

	public static void setNoProxy(String np)
	{
		if (np.startsWith("http://"))
		{
			noProxy = np.substring(7);
		}
	}

/**.
 *	proxyStatus returns proxy status for given URL. 
 *	For some URLs(specified with NO Proxy), proxy will not be used. 
 *	The given URL is checked against the NoProxy URL. If match found, false is returned indicating proxy should not be used
 *	Otherwise the proxy status is directly returned.	
 *	Sometimes only status of proxy is needed. In that case, empty string is passed as parameter.
 *	
 */
	public static boolean proxyStatus(String url)
	{
		//ASSUMPTION: All the URL start with http

		if (url.startsWith("http://"))
		{
			String tmpUrl = url.substring(7);	// get host name
			// if the host name starts with the a hostname for which  proxy should not be used, return false
			if (tmpUrl.startsWith(noProxy))	
			{
				return false;
			}
		}
		return useProxy;
	}

	public static String getResultFileName() // give the file name for storing transaction results.
	{
		String temp = new String(resFile);
		return temp;
	}

	public static String getProfileFileName() // give the file name for storing profile for various jobs.
	{
		String temp = new String(profileFile);
		return temp;
	}

/* The method getUploadDetail() is used to get info about uploading the results. 
 * An object of PageDetails is returned with all the details(such as HTTP Method, Version, Port, URL) filled in.
 * The fields of parameters are left blank and can be filled afterwards. 
 */
	public static PageDetails getUploadDetail()
	{
		PageDetails tmp = new PageDetails(upResMethod, upResVers, upResURL, upResPort,"", "", "" );
		return tmp;
	}


/* The method getAliveDetail() is used to send alive message to Reporting Centre. 
 * An object of PageDetails is returned with all the details(such as HTTP Method, Version, Port, URL) filled in.
 * The fields of parameters are left blank and can be filled afterwards. 
 */
	public static PageDetails getAliveDetail()
	{
		PageDetails tmp = new PageDetails(aliveMethod, aliveVers, aliveURL, alivePort,"", "", "" );
		return tmp;
	}

/* The method getProfileDlDetail() is used to download Job Profile from Reporting Centre. 
 * An object of PageDetails is returned with all the details(such as HTTP Method, Version, Port, URL) filled in.
 * The fields of parameters are left blank and can be filled afterwards. 
 */
	public static PageDetails getJobDlDetail()
	{
		PageDetails tmp = new PageDetails(jobdlMethod, jobdlVers, jobdlURL, jobdlPort,"", "", "" );
		return tmp;
	}

/* The method getRegDetail() is used to register Delegate with Reporting Centre. 
 * An object of PageDetails is returned with all the details(such as HTTP Method, Version, Port, URL) filled in.
 * The fields of parameters are left blank and can be filled afterwards. 
 */
	public static PageDetails getRegDetail()
	{
		PageDetails tmp = new PageDetails(regMethod, regVers, regURL, regPort,"", "", "" );
		return tmp;
	}
	
	public static String getDelID()
	{
		return delID;
	}
}

