
/**.
 *  This class specifies the details needed to fetch a page.
 *  All the parameters required to send the request for page are listed.   
 *  The constructor accepts all the parameters and sets them.
 *  If some parameters of page are not available, then they can be set by using the method setPgParam().
 * 
 */

class PageDetails
{
	String	Method; 	// HTTP Method - GET/POST/...
	String	HTTPV;		// HTTP Version
	String	URL;		// Page URL 
	int	Port;		// Port number to be used
	String	PgParam;	// Page Parameters. 
	String	DataSet;	// The data values to be used for above parameters
	String	KeyWord;	// Set of keywords to be checked on the page. The keywords are used to verify the correct content delivery of the webpage

	PageDetails(String M, String H, String U, int PortNum, String Param, String D, String K)
	{
		Method = new String(M);
		HTTPV = new String(H);
		URL = new String(U);
		Port = PortNum;
		PgParam = new String(Param);
		DataSet = new String(D);
		KeyWord = new String(K);
	}

	PageDetails() // constructor when no parameter is specified
	{
		Method = new String();
		HTTPV = new String();
		URL = new String();
		Port = 0 ;
		PgParam = new String();
		DataSet = new String();
		KeyWord = new String();
	}	

	public void setPgParam(String Param, String Data, String Key)
	{	
		PgParam = Param;
		DataSet = Data;
		KeyWord = Key;
	}

	public String toString()
	{
		String	tmp = new String("");
		String	nl = new String("\n");	// new line

		tmp	+=  "***"+nl;
		tmp	+=  "HTTP Method : " + Method + nl ; 
		tmp	+=  "HTTP Version: " + HTTPV + nl ;
		tmp	+=  "Page URL	 : " + URL + nl ;
		tmp	+=  "Page Port	 : " + Port + nl ;
		tmp	+=  "Page Param	 : " + PgParam + nl ;
		tmp	+=  "Page Data 	 : " + DataSet + nl ;
		tmp	+=  "Page Keyword: " + KeyWord + nl ;
		tmp	+=  "***"+nl;

		return tmp;
	}
}


