

/**. 
 *  This class is for sending the Alive message to the Reporting Centre.
 *  It runs as a thread and send alive message after a specified interval specified in configuration.
 *  The response of the Alive message may trigger some other functionality. 
 *  The most simple repsonse from Reporting Centre is simply a OK message.
 *  
 *
 */

import java.io.*;
import java.util.*;
import java.lang.*;

class SendAlive extends Thread
{
	Thread t;
	
	SendAlive()
	{
		t = new Thread(this);
		t.start();
	}
	
	public void run()
	{	
		String pgParam 	= new String("");	// page parameters
		String pgParVal	= new String("");	// values for respective page parameters
		// String 		s = new String("");
		String		delim = new String("|");	// delimeter to seperate parameters
		int 		i=0;
		PageDetails	pgDet; 
		PageResult 	pgRes;
		Page		p;
		String 		fName = new String("");	 // name of the file in which the response from Reporting Centre is stored
		ArrayList	getJob = new ArrayList();

		// Will never come out of this loop
		while (true)
		{
			Date D = new Date();
			long L = D.getTime();

                        // Send Delegate ID and current time stamp as parameters.
                        pgParam         = "ID"+delim+"TS"+delim;
                        pgParVal        = Global.getDelID()+delim + L+delim;

			pgDet = Global.getAliveDetail();
			pgRes = new PageResult();

			pgDet.setPgParam(pgParam, pgParVal,"" );

			p = new Page(pgDet, pgRes);
			try
			{
				p.t.join();
			}
			catch (InterruptedException e)
			{	
				System.out.println("SendAlive : Thread Interrupted");
			}
			fName = pgRes.pgFile;

			try
			{
				BufferedReader input = new BufferedReader(new FileReader(fName));
				String s = new String("");
		
				while((s=input.readLine())!= null) 
				{
					// Currently only output OK, FAIL and ADDJOB are interpreted. 
					// More commands can be added with more string comparisions. 
					
					if (s.startsWith("OK"))
					{
						// everything is fine. 
						System.out.println("SendAlive : OK "+ D);
					}
					if (s.startsWith("FAIL"))
					{
						// something is wrong. try again after some time. 
						System.out.println("SendAlive : FAIL "+ D);
					}
					if (s.startsWith("ADDJOB"))
					{
						// write code to get other parameters 
						// the parameters are jobid and jobtype 
						String jid = new String("");
						String jtype = new String("");

						StringTokenizer st = new StringTokenizer(s);
						st.nextToken();	// skip first token
						jid = st.nextToken();	
						jtype = st.nextToken();
		
						PendingJob pj = new PendingJob(jid, jtype);
						// add to the list of jobs for which profile is to be fetched.
						getJob.add(pj); 
					}
				}// end while s = input.readline

				input.close();

				// now submit these parameters to other module which will get profiles for these job
				if (getJob.size() > 0)
					Profile.getProfiles(getJob);
			
			}// end try 
			catch(IOException e) 
			{
				System.out.println("SendAlive: IOException \n"+e);
			}

			// delete the downloaded file 
			pgRes.delPageFile();

			// sleep for 15 minutes 
			try
			{
				Thread.sleep(900000);	//  900000 milliseconds = 15 minutes
			}
			catch(InterruptedException e)
			{
				System.out.println("SendAlive: Interrupt in sleep ");
			}
		}// end while true
	} // end run


}
