<?php

/*	Generating the graph of AVAILABILITY for required Transaction for SINGLE DAY
 *
 *	This graph can be generated in two ways - 1. Location-wise availability 2. Global availability
 *
 */

	// add http header to make sure that the response is not cached
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 

	$jobid	= $_GET['jid'];	// Job ID
	$day	= $_GET['day'];	// Day 
	$mon	= $_GET['mon'];	// Month
	$yr	= $_GET['yr'];	// Year	

	// Locations to be taken into consideration.
	// Value is either "All" (Locationwise Availability) or  "Global"(Global Availability)
	$loc	= $_GET['loc'];	

	// for the day given above plot the graph

	$datestr = $yr."-".$mon."-".$day;	// construct the date string in YYYY-MM-DD format
	$todayts = strtotime($datestr); 	// get time stamp for that day

	// default values for interval 
	$interval_min =	60; // interval to be used in graph. 
	$sample_point = 24; // number of points on x-axis (equals number of hours in a day) 

	// decide the interval on x-axis with PPH Load 
	// this is to get finer granularity of results
	$interval_q = "SELECT NumStep , PPHLoad FROM JobInfo WHERE JobID ='".$jobid."'"; 

	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("Unable to connect to server."); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("Unable to select database.");

	$res_int = mysql_query($interval_q) or die("Unable to execute query");
	$int_row = mysql_fetch_assoc($res_int);

	$numstep = $int_row['NumStep'];	// get number of steps in transaction
	
	// if  pphload / numstep > 1.5 , set interval_min = 30
	if ( 2 * $int_row['PPHLoad'] > 3*$int_row['NumStep'])
	{
		$interval_min = 30;
		$sample_point = 48;
	}

	mysql_free_result($res_int);

	// **** this codes is for generating graph. 
	// create empty canvas
	include("jpgraph/jpgraph.php");
	include("jpgraph/jpgraph_line.php");

	// Create the graph. These two calls are always required
	$graph = new Graph(700,500);
	$graph->SetScale("textlin");
	// $graph->SetScale("textlin");

	// ***  create scale for x-axis
	$datax = array(0); 	// text labels for x-axis
	$step = ($sample_point > 24 ? 0.5:1);

	for ($ind=1;$ind<= $sample_point; $ind++)
	{
		$datax[$ind] = $datax[$ind-1] + $step;
	}

	// colors used for different line plots
	$linecol = array('darkorchid','coral','khaki','magenta4','cyan'); 
	$linest  = array('solid', 'dashed', 'dotted', 'solid', 'dotted');

	// ****


///============== Availability by Location ========================///
	if ($loc == "All")
	{

	// location of the delegate monitoring this job
	$locdelq = "SELECT DReg FROM TrRes, DelegateInfo  WHERE TrRes.JobID='$jobid' AND TrRes.DelID = DelegateInfo.DelID GROUP BY DReg;";

	$locres = mysql_query($locdelq) or die("Unable to execute query : locdelq ");

	$numloc = 0; 	// number of locations from which transaction is monitored

	// generate results for each location
	while($locrow = mysql_fetch_assoc($locres))
	{
		$location = $locrow['DReg'];

		// Availability
		$avl = array(0); 

		// two dimensional array for holding result values
		// first row holds the number of tests in error and second row holds the total number of tests collected
		// (Total - Err)/Total  will give us the availability (which will be stored in avl array)
		$ResArr[0][0] = 0;

		// initialize the array
		for($init=0; $init <= $sample_point; $init++)
		{
			$ResArr[$init][0] = 0;	// number of tests in error 
			$ResArr[$init][1] = 0;	// total number of tests conducted
			$avl[$init] = "-";      //availability array - initialized to "no data"
		}

		//select all the results that are in error 
		$avtr_q = "SELECT distinct UNIX_TIMESTAMP(TrStart) as ts, TrErr FROM TrRes,DelegateInfo WHERE JobID ='".$jobid."' AND TrRes.DelID = DelegateInfo.DelID AND DelegateInfo.DReg='".$location."' AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$todayts." AND ".($todayts + 24*60*60)." ;";

		$res    = mysql_query($avtr_q) or die("Unable to execute query :avtr_q");

		while ($row = mysql_fetch_assoc($res))
		{
			$timest         = $row['ts'];

			// find the index for the result
			$ind    = floor( ((($timest - $todayts)/60) + ($interval_min/2)) / ($interval_min));

			if ($ind <= $sample_point)
			{
				$ResArr[$ind][1] += 1;	// number of tests increased by 1  

				if ($row['TrErr'] > 0)		// test is in error
					$ResArr[$ind][0] += 1;	// number of tests in error increased by 1
			}
		}
		/* Free resultset */
		mysql_free_result($res);

		// flag to indicate there is atleast one test conducted in the given duration
		$flag = 0;

		// calculate availability 
		for ($ind = 0; $ind <= $sample_point; $ind++)
		{
			if ($ResArr[$ind][1] > 0)
			{
				$avl[$ind] = (($ResArr[$ind][1]-$ResArr[$ind][0]) / $ResArr[$ind][1]);
				$flag = 1;
			}
			else  // if there is no data, it will be treated as null value
			{
				$avl[$ind] = "-";
			}
		}

		if ($flag == 0)
		{
			$avl[0] = 0;
		}

		// Create the linear plot for this location
		$lineplot[$numloc]=new LinePlot($avl); 
		$lineplot[$numloc]->SetColor($linecol[$numloc]); 
		$lineplot[$numloc]->SetStyle($linest[$numloc]); 
		$lineplot[$numloc]->SetWeight(2);
		$lineplot[$numloc]->SetLegend($location);

		// Add the plot to the graph 
		$graph->Add($lineplot[$numloc]); 

		$numloc += 1;
	} // end while locrow

	mysql_close($dbconn);
	mysql_free_result($locres);

	// Legend is necessary when graphs are plot for different locations
	// set legend position and direction
	$graph->legend->Pos(0.05,0.98,"left","bottom");
	$graph->legend->SetLayout(LEGEND_HOR);
	$graph->legend->SetLineWeight(2);

	} // end if loc == all
///================ Availability by Location Ends ==================///


///================ Global Availability ============================///
	if ($loc == "Global")
	{

		// Availability
		$avl = array(0); 

		// two dimensional array for holding result values
		// first row holds the number of tests in error and second row holds the total number of tests collected
		// (Total - Err)/Total  will give us the availability (which will be stored in avl array)
		$ResArr[0][0] = 0;

		// initialize the array
		for($init=0; $init <= $sample_point; $init++)
		{
			$ResArr[$init][0] = 0;	// number of tests in error 
			$ResArr[$init][1] = 0;	// total number of tests conducted
			$avl[$init] = "-";      //availability array - initialized to "no data"
		}

		//select all the results that are in error 
		$avtr_q = "SELECT distinct UNIX_TIMESTAMP(TrStart) as ts, TrErr FROM TrRes WHERE JobID ='".$jobid."' AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$todayts." AND ".($todayts + 24*60*60)." ;";

		$res    = mysql_query($avtr_q) or die("Unable to execute query :avtr_q");

		while ($row = mysql_fetch_assoc($res))
		{
			$timest         = $row['ts'];

			// find the index for the result
			$ind    = floor( ((($timest - $todayts)/60) + ($interval_min/2)) / ($interval_min));

			if ($ind <= $sample_point)
			{
				$ResArr[$ind][1] += 1;	// number of tests increased by 1  

				if ($row['TrErr'] > 0)		// test is in error
					$ResArr[$ind][0] += 1;	// number of tests in error increased by 1
			}
		}
		/* Free resultset */
		mysql_free_result($res);

		// flag to indicate there is atleast one test conducted in the given duration
		$flag = 0;

		// calculate availability 
		for ($ind = 0; $ind <= $sample_point; $ind++)
		{
			if ($ResArr[$ind][1] > 0)
			{
				$avl[$ind] = (($ResArr[$ind][1]-$ResArr[$ind][0]) / $ResArr[$ind][1]);
				$flag = 1;
			}
			else  // if there is no data, it will be treated as null value
			{
				$avl[$ind] = "-";
			}
		}

		if ($flag == 0)
		{
			$avl[0] = 0;
		}

		// Create the linear plot for this location
		$lineplot=new LinePlot($avl); 
		$lineplot->SetColor("brown3"); 
		$lineplot->SetWeight(2);

		// Add the plot to the graph 
		$graph->Add($lineplot); 

	} // end if loc == global
///================ Global Availability Ends ==================// 

	// Nice shadow
	$graph->SetColor('ivory');
	$graph->SetShadow();

	// Show  grid in background
	$graph->xgrid->Show();

	// Set footer 
	$str = "Generated at  ".gmdate("M d Y H:i:s", time())." GMT ";
	$graph->footer->right->Set($str);
	$graph->footer->center->Set("(C) CSE, IIT Kanpur ");

	// Setup margin and titles 
	$graph->img->SetMargin(60,20,20,60); 
	$graph->SetMarginColor("antiquewhite");
	$graph->title->Set(date("M d Y",$todayts)); // date is the title 

	$graph->yaxis->SetTitlemargin(45);
	$graph->xaxis->title->Set("Hour of Day"); 
	$graph->yaxis->title->Set("Availability");

	$graph->yaxis->scale->SetGrace(10,0); 			// Make some room at top of graph	
	$graph->yaxis->scale->ticks->SupressMinorTickMarks(); 	// Supress minor ticks
	$graph->xaxis->SetTickLabels($datax);
	$graph->xaxis->SetTextLabelInterval(2);

	$graph->Stroke();
?>
