<?php

/*	Generating the graph for availability of a Transaction for A SPECIFIED PERIOD 
 *	The graph can be either for complete transaction or individual step of transaction
 */

	// add http header to make sure that the response is not cached
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 

	$jobid = $_GET['jid']; 	// job ID

	// start day of result
	$stday	= $_GET['std']; // day
	$stmon	= $_GET['stm']; // month
	$styr	= $_GET['sty']; // year

	// end day of result
	$enday	= $_GET['end'];	// day
	$enmon	= $_GET['enm'];	// month
	$enyr	= $_GET['eny'];	// year

	// Locations to be taken into consideration.
	// Value is either "All" (Locationwise Availability) or  "Global"(Global Availability)
	$loc	= $_GET['loc'];	

	$day1 = strtotime($styr."-".$stmon."-".$stday."-");	// timestamp for starting day
	$day2 = strtotime($enyr."-".$enmon."-".$enday."-");	// timestamp for ending day

	$diff = ($day2-$day1)/(24*60*60); // difference in number of days

	if ($diff > 7) // if the difference between days is greater than 7 days, give error message
	{
		exit();	
	}

	switch ($diff)
	{
		case 1:
			$interval_min = 60;  // interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 2: 
			$interval_min = 120;// interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 3: 
			$interval_min = 180; // interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 4: 
			$interval_min = 240; // interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 5: 
			$interval_min = 360; // interval to be used in graph. 
			$sample_point = 20; // number of points on x-axis 
			break;
		case 6: 
			$interval_min = 360; // interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 7: 
			$interval_min = 360; // interval to be used in graph. 
			$sample_point = 28; // number of points on x-axis 
			break;
	}

	// **** this codes is for generating graph. 
	include("jpgraph/jpgraph.php");
	include("jpgraph/jpgraph_line.php");

	// Create the graph. These two calls are always required 
	$graph = new Graph(700,500); 
	$graph->SetScale("textlin"); 
	// ****

	// ***  create scale for x-axis
	$step	= $interval_min / 60;	// calculate number of hours to be used as step
	$dy	= $day1;		// timestamp for first day
	$hr	= 0; 			// start hour 
	
	for ($ind=0;$ind<= $sample_point; $ind++)
	{

		$datax[$ind] = date("Y:M:d",$dy)." ".$hr." Hrs "; // text labels for x-axis

		$hr += $step;	// find next label 
		$hr %=24;
		$dy += $interval_min * 60; // update timestamp
	}

	// colors used for different line plots
	$linecol = array('darkorchid','coral','khaki','magenta4','cyan'); 
	$linest  = array('solid', 'dashed', 'dotted', 'solid', 'dotted');

	//***

	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("Unable to connect to server."); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("Unable to select database.");

///============== Availability by Location ========================///
	if ($loc == "All")
	{

	// location of the delegate monitoring this job
	$locdelq = "SELECT DReg FROM TrRes, DelegateInfo  WHERE TrRes.JobID='{$_GET['jid']}' AND TrRes.DelID = DelegateInfo.DelID GROUP BY DReg;";

	$locres = mysql_query($locdelq) or die("Unable to execute query : locdelq ");

	$numloc = 0; 	// number of locations from which transaction is monitored

	while($locrow = mysql_fetch_assoc($locres))
	{
		$location = $locrow['DReg'];

		// Availability
		$avl = array(0); 

		// two dimensional array for holding result values
		// first row holds the number of tests in error and second row holds the total number of tests collected
		// (Total - Err)/Total  will give us the availability (which will be stored in avl array)
		$ResArr[0][0] = 0;

		// initialize the array
		for($init=0; $init <= $sample_point; $init++)
		{
			$ResArr[$init][0] = 0;	// number of tests in error 
			$ResArr[$init][1] = 0;	// total number of tests conducted
			$avl[$init] = "-";      //availability array - initialized to "no data"
		}

		//select all the results in err
		$avtr_q = "SELECT distinct UNIX_TIMESTAMP(TrStart) as ts, TrErr FROM TrRes,DelegateInfo WHERE JobID ='".$jobid."' AND TrRes.DelID = DelegateInfo.DelID AND DelegateInfo.DReg='".$location."' AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$day1." AND ".$day2." ;";

		$res	= mysql_query($avtr_q) or die("Unable to execute query :avtr_q");

		while ($row = mysql_fetch_assoc($res))
		{
			$timest 	= $row['ts'];

			// find the index for the result
			$ind	= floor( ((($timest - $day1)/60) + ($interval_min/2)) / ($interval_min)); 

			if ($ind <= $sample_point)
			{
				$ResArr[$ind][1] += 1;	// number of tests increased by 1  

				if ($row['TrErr'] > 0)		// test is in error
					$ResArr[$ind][0] += 1;	// number of tests in error increased by 1
			}
		}
		mysql_free_result($res);

		// flag to indicate there is atleast one test conducted in the given duration
		$flag = 0;

		// calculate availability 
		for ($ind = 0; $ind <= $sample_point; $ind++)
		{
			if ($ResArr[$ind][1] > 0)
			{
				$avl[$ind] = (($ResArr[$ind][1]-$ResArr[$ind][0]) / $ResArr[$ind][1]);
				$flag = 1;
			}
			else  // if there is no data, it will be treated as null value
			{
				$avl[$ind] = "-";
			}
		}

		if ($flag == 0)
		{
			$avl[0] = 0;
		}

		// Create the linear plot for this location
		$lineplot[$numloc]=new LinePlot($avl); 
		$lineplot[$numloc]->SetColor($linecol[$numloc]); 
		$lineplot[$numloc]->SetStyle($linest[$numloc]); 
		$lineplot[$numloc]->SetWeight(2);
		$lineplot[$numloc]->SetLegend($location);

		// Add the plot to the graph 
		$graph->Add($lineplot[$numloc]); 

		$numloc +=1;
	} // end while locrow

	mysql_close($dbconn);
	mysql_free_result($locres);
	
	// set legend position and direction
	$graph->legend->Pos(0.05,0.98,"left","bottom");
	$graph->legend->SetLayout(LEGEND_HOR);
	$graph->legend->SetLineWeight(2);

	} // end if loc == all
///================ Availability by Location Ends ==================///
	

///================ Global Availability ============================///
	if ($loc == "Global")
	{
		// Availability
		$avl = array(0); 

		// two dimensional array for holding result values
		// first row holds the number of tests in error and second row holds the total number of tests collected
		// (Total - Err)/Total  will give us the availability (which will be stored in avl array)
		$ResArr[0][0] = 0;

		// initialize the array
		for($init=0; $init <= $sample_point; $init++)
		{
			$ResArr[$init][0] = 0;	// number of tests in error 
			$ResArr[$init][1] = 0;	// total number of tests conducted
			$avl[$init] = "-";      //availability array - initialized to "no data"
		}

		//select all the results that are in error 
		$avtr_q = "SELECT distinct UNIX_TIMESTAMP(TrStart) as ts, TrErr FROM TrRes WHERE JobID ='".$jobid."' AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$day1." AND ".$day2." ;";

		$res    = mysql_query($avtr_q) or die("Unable to execute query :avtr_q");

		while ($row = mysql_fetch_assoc($res))
		{
			$timest         = $row['ts'];

			// find the index for the result
			$ind    = floor( ((($timest - $day1)/60) + ($interval_min/2)) / ($interval_min));

			if ($ind <= $sample_point)
			{
				$ResArr[$ind][1] += 1;	// number of tests increased by 1  

				if ($row['TrErr'] > 0)		// test is in error
					$ResArr[$ind][0] += 1;	// number of tests in error increased by 1
			}
		}
		/* Free resultset */
		mysql_free_result($res);
		mysql_close($dbconn);

		// flag to indicate there is atleast one test conducted in the given duration
		$flag = 0;

		// calculate availability 
		for ($ind = 0; $ind <= $sample_point; $ind++)
		{
			if ($ResArr[$ind][1] > 0)
			{
				$avl[$ind] = (($ResArr[$ind][1]-$ResArr[$ind][0]) / $ResArr[$ind][1]);
				$flag = 1;
			}
			else  // if there is no data, it will be treated as null value
			{
				$avl[$ind] = "-";
			}
		}

		if ($flag == 0)
		{
			$avl[0] = 0;
		}

		// Create the linear plot for this location
		$lineplot=new LinePlot($avl); 
		$lineplot->SetColor("brown3"); 
		$lineplot->SetWeight(2);

		// Add the plot to the graph 
		$graph->Add($lineplot); 

	} // end if loc == global
///================ Global Availability Ends ==================// 

	// Set footer 
	$str = "Generated at  ".gmdate("M d Y H:i:s", time())." GMT ";
	$graph->footer->right->Set($str);
	$graph->footer->center->Set("(C) CSE, IIT Kanpur ");

	// Nice shadow and color
	$graph->SetShadow();
	$graph->SetColor('ivory');

	// Show  grid in background
	$graph->xgrid->Show();

	// Setup margin and titles 
	$graph->img->SetMargin(60,20,20,150); 
	$graph->SetMarginColor("antiquewhite");
	$titlestr = date("M d, Y", $day1)." -TO- ".date("M d, Y", $day2);
	$graph->title->Set($titlestr); // date is the title 

	$graph->yaxis->SetTitlemargin(45);
	$graph->yaxis->scale->SetGrace(10,0); 	// Make some room at top and bottom of graph	
	// $graph->xaxis->title->Set("Day & Hour"); 
	$graph->xaxis->SetLabelAngle(90); 	// labels will be displayed at 90 degrees
	$graph->yaxis->title->Set("Availability");

	$graph->yaxis->scale->ticks->SupressMinorTickMarks(); // Supress minor ticks
	$graph->xaxis->SetTickLabels($datax);
	$graph->xaxis->SetTextLabelInterval(2);

	$graph->Stroke();

?>
