<?php

/*	Generating the graph of Response Time in various regions for required Transaction for SINGLE DAY
 *	The graph can be either for complete transaction 
 *
 *	THIS CODE IS VERY SIMILAR TO restimeday.php
 *	The ONLY difference is we are plotting DIFFERENT GRAPHS for EACH LOCATION. 
 */	

	// add http header to make sure that the response is not cached
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 

	$jobid	= $_GET['jid'];	// Job ID
	$day	= $_GET['day'];	// Day 
	$mon	= $_GET['mon'];	// Month
	$yr	= $_GET['yr'];	// Year	
	$type   = $_GET['type'];// Type of result - PG for pagewise result and TRA for transaction

	$loctmp = $_GET['loc']; // locations of delegate - it wil be something like "loc1,loc2,loc3,"
	
	// the character comma (",") acts as delimiter for the string of locations
	$delim = ",";

	// remove the trailing "," 
	$loctmp = trim($loctmp , $delim );

	// get all the locations in the array 
	$location = explode($delim, $loctmp);

	$datestr = $yr."-".$mon."-".$day;	// construct the date string in YYYY-MM-DD format
	$todayts = strtotime($datestr); 	// get time stamp for that day

	// default values for interval 
	$interval_min =	60; // interval to be used in graph. 
	$sample_point = 24; // number of points on x-axis  

	$interval_q = "SELECT NumStep , PPHLoad FROM JobInfo WHERE JobID ='".$jobid."'"; 

	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("Unable to connect to server."); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("Unable to select database.");
	
	$res_int = mysql_query($interval_q) or die("Unable to execute query");
	$int_row = mysql_fetch_assoc($res_int);

	$numstep = $int_row['NumStep'];	// get number of steps in transaction
	
	// if  pphload / numstep > 1.5 , set interval_min = 30
	if ( 2 * $int_row['PPHLoad'] > 3*$int_row['NumStep'])
	{
		$interval_min = 30;
		$sample_point = 48;
	}

	mysql_free_result($res_int);

	if ($type != 'TRA') // if type is not TRA, exit
	{
		exit();
	}


//=============== display results for a transaction =================================//

	// *** create empty canvas for graph 
	$datax = array(0); // text labels for x-axis
	$step = ($sample_point > 24 ? 0.5:1);

	// create scale for x-axis
	for ($ind=1;$ind<= $sample_point; $ind++)
	{
		$datax[$ind] = $datax[$ind-1] + $step;
	}

	include("jpgraph/jpgraph.php");
	include("jpgraph/jpgraph_line.php");

	// Create the graph. These two calls are always required 
	$graph = new Graph(700,500); 
	$graph->SetScale("textlin"); 

	// colors and styles used for different line plots
	$linecol = array('darkorchid','coral','firebrick1','magenta4','cyan'); 
	$linest  = array('solid', 'dashed', 'dotted', 'solid', 'dotted');

	$numloc = 0;

	while ($numloc < count($location))
	{

		// two dimensional array for holding result values
		// first row holds the cumulative response time and second row holds the number of samples 
		// the division will give us the average response time
		$ResArr[0][0] = 0;	
		
		// average response time
		$avgr[0] = 0;	
		
		// initialize the array 
		for($init=0; $init <= $sample_point; $init++)
		{
			$ResArr[$init][0] = 0;	// response time
			$ResArr[$init][1] = 0;	// number of samples
			$avgr[$init] = 0;	// average response time
		}


		// select results for given day and location  which are not in error 
		
		$restr_q = "SELECT UNIX_TIMESTAMP(TrStart) as ts, EEResponse FROM TrRes, DelegateInfo WHERE JobID ='".$jobid."' AND  TrErr < 1  AND TrRes.DelID = DelegateInfo.DelID AND DelegateInfo.DReg='".$location[$numloc]."' AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$todayts." AND ".($todayts + 24*60*60)." ;";

		$res	= mysql_query($restr_q) or die("Unable to execute query : restr_q");

		// number of tests conducted is equal to number of results returned
		$numres = mysql_num_rows($res);

		while ($row = mysql_fetch_assoc($res))
		{
			$timest 	= $row['ts'];
			$resptime	= $row['EEResponse'];
		
			// calculate the array index for this result 
			$ind	= floor( ((($timest - $todayts)/60) + ($interval_min/2)) / ($interval_min));  

			if ($ind <= $sample_point)
			{
				$ResArr[$ind][0] += $resptime;	// add response time for this test

				// number of tests increased by 1  - this will be used to calculate avg. response time	
				$ResArr[$ind][1] += 1;		
			}
		}

		/* Free resultset */
		mysql_free_result($res);     

		// flag to check there is atleast one point on the result. 
		// flag = 1 means there exists atleast one point, flag =0 means otherwise
		$flag = 0;

		// calculate average
		for ($ind = 0; $ind <= $sample_point; $ind++)
		{
			if ($ResArr[$ind][1] > 0)
			{
				$avgr[$ind] = ceil($ResArr[$ind][0] / $ResArr[$ind][1]);
				
				$flag = 1; // there atleast one point in the graph
			}
			else  // if there is no data, it will be treated as null value
			{
				$avgr[$ind] = "-";	
			}
		}

		// if there is no point, insert a dummy value
		if ($flag == 0)
		{
			$avgr[0] = 0;	//dummy value 
		}

		// Create the linear plot for this location
		$lineplot[$numloc]=new LinePlot($avgr); 
		$lineplot[$numloc]->SetColor($linecol[$numloc]); 
		$lineplot[$numloc]->SetStyle($linest[$numloc]); 
		$lineplot[$numloc]->SetWeight(2);
		$lineplot[$numloc]->SetLegend($location[$numloc]);

		// Add the plot to the graph 
		$graph->Add($lineplot[$numloc]); 

		$numloc += 1;
	} // end while


	// Set footer 
	$str = "Generated at  ".gmdate("M d Y H:i:s", time())." GMT ";
	$graph->footer->right->Set($str);
	$graph->footer->center->Set("(C) CSE, IIT Kanpur ");

	// Nice shadow and color
	$graph->SetShadow();
	$graph->SetColor('ivory');

	// Show  grid in background
	$graph->xgrid->Show();

	// Setup margin and titles 
	$graph->img->SetMargin(60,20,20,60); 
	$graph->SetMarginColor("antiquewhite");
	$graph->title->Set(date("M d Y",$todayts)); // date is the title 

	// set legend position and direction
	$graph->legend->Pos(0.05,0.98,"left","bottom");
	$graph->legend->SetLayout(LEGEND_HOR);
	$graph->legend->SetLineWeight(2);

	$graph->yaxis->SetTitlemargin(45);
	$graph->yaxis->scale->SetGrace(10,0); 	// Make some room at top and bottom of graph	
	$graph->xaxis->title->Set("Hour of Day"); 
	$graph->yaxis->title->Set("Response Time in millisecond");

	$graph->yaxis->scale->ticks->SupressMinorTickMarks(); // Supress minor ticks
	$graph->xaxis->SetTickLabels($datax);
	$graph->xaxis->SetTextLabelInterval(2);
	
	// Display the graph 
	$graph->Stroke();
	mysql_close($dbconn);	/* Closing connection */

?>
