<?php

/*	Generating the graph of Response time for required Transaction for SINGLE DAY
 *	The graph can be either for complete transaction or individual step of transaction
 *	
 */	


	// add http header to make sure that the response is not cached
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 

	$jobid	= $_GET['jid'];	// Job ID
	$day	= $_GET['day'];	// Day 
	$mon	= $_GET['mon'];	// Month
	$yr	= $_GET['yr'];	// Year	
	$type   = $_GET['type'];// Type of result - PG for pagewise result and TRA for transaction
	$location=$_GET['loc'];	// Location from which results should be taken into consideration

	$datestr = $yr."-".$mon."-".$day;	// construct the date string in YYYY-MM-DD format
	$todayts = strtotime($datestr); 	// get time stamp for that day

	// default values for interval 
	$interval_min =	60; // interval to be used in graph. 
	$sample_point = 24; // number of points on x-axis  

	$interval_q = "SELECT NumStep , PPHLoad FROM JobInfo WHERE JobID ='".$jobid."'"; 

	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("Unable to connect to server."); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("Unable to select database.");
	
	$res_int = mysql_query($interval_q) or die("Unable to execute query");
	$int_row = mysql_fetch_assoc($res_int);

	$numstep = $int_row['NumStep'];	// get number of steps in transaction
	
	// if  pphload / numstep > 1.5 , set interval_min = 30
	if ( 2 * $int_row['PPHLoad'] > 3*$int_row['NumStep'])
	{
		$interval_min = 30;
		$sample_point = 48;
	}

	mysql_free_result($res_int);

//=============== display results for a transaction =================================//

	if ($type == 'TRA') // display results for transaction
	{

		// two dimensional array for holding result values
		// first row holds the cumulative response time and second row holds the number of samples 
		// the division will give us the average response time
		$ResArr[0][0] = 0;	
		
		// average response time
		$avgr[0] = 0;	
		
		// initialize the array 
		for($init=0; $init <= $sample_point; $init++)
		{
			$ResArr[$init][0] = 0;	// response time
			$ResArr[$init][1] = 0;	// number of samples
			$avgr[$init] = 0;	// average response time
		}

		// select results for given day and location  which are not in error 
		
		if (strncmp($location,"All",3) == 0) 	// select results from all locactions
		{

		$restr_q = "SELECT UNIX_TIMESTAMP(TrStart) as ts, EEResponse FROM TrRes WHERE JobID ='".$jobid."' AND TrErr < 1 AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$todayts." AND ".($todayts + 24*60*60)." ;";

		}
		else 	// select result from specified location
		{

		$restr_q = "SELECT UNIX_TIMESTAMP(TrStart) as ts, EEResponse FROM TrRes, DelegateInfo WHERE JobID ='".$jobid."' AND  TrErr < 1  AND TrRes.DelID = DelegateInfo.DelID AND DelegateInfo.DReg='".$location."' AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$todayts." AND ".($todayts + 24*60*60)." ;";

		}

		$res	= mysql_query($restr_q) or die("Unable to execute query : restr_q");

		// number of tests conducted is equal to number of results returned
		$numres = mysql_num_rows($res);

		while ($row = mysql_fetch_assoc($res))
		{
			$timest 	= $row['ts'];
			$resptime	= $row['EEResponse'];
		
			// calculate the array index for this result 
			$ind	= floor( ((($timest - $todayts)/60) + ($interval_min/2)) / ($interval_min));  

			if ($ind <= $sample_point)
			{
				$ResArr[$ind][0] += $resptime;	// add response time for this test
				$ResArr[$ind][1] += 1;		// number of tests increased by 1  - this will be used to calculate avg. response time	
			}
		}

		/* Free resultset */
		mysql_free_result($res);     
		mysql_close($dbconn);	/* Closing connection */

		for ($ind = 0; $ind <= $sample_point; $ind++)
		{
			if ($ResArr[$ind][1] > 0)
			{
				$avgr[$ind] = ceil($ResArr[$ind][0] / $ResArr[$ind][1]);
				
			/*	echo $ind."\t\t";
				echo $ResArr[$ind][0]."\t\t";
				echo $ResArr[$ind][1]."\t\t";
				echo $avgr[$ind]."\n\n";
			*/
			
			}
			else  // if there is no data, it will be treated as null value
			{
				$avgr[$ind] = "-";	
			}
		}

		$datax = array(0); // text labels for x-axis
		$step = ($sample_point > 24 ? 0.5:1);

		// create scale for x-axis
		for ($ind=1;$ind<= $sample_point; $ind++)
		{
			$datax[$ind] = $datax[$ind-1] + $step;
		}

		include("jpgraph/jpgraph.php");
		include("jpgraph/jpgraph_line.php");
	
		// Create the graph. These two calls are always required 
		$graph = new Graph(700,500); 
		$graph->SetScale("textlin"); 
		
		// Nice shadow
		$graph->SetColor('ivory');
		$graph->SetShadow();

		// Show  grid in background
		$graph->xgrid->Show();

		// Set footer 
		$str = "Generated at  ".gmdate("M d Y H:i:s", time())." GMT ";
		$graph->footer->right->Set($str);
		$graph->footer->center->Set("(C) CSE, IIT Kanpur ");

		// Setup margin and titles 
		$graph->img->SetMargin(60,20,20,60); 
		$graph->SetMarginColor("antiquewhite");
		$graph->title->Set(date("M d Y",$todayts)); // date is the title 

		$graph->yaxis->SetTitlemargin(45);
		$graph->xaxis->title->Set("Hour of Day"); 
		$graph->yaxis->title->Set("Response Time in millisecond");

		$graph->yaxis->scale->SetGrace(10,0); 			// Make some room at top and bottom of graph	
		$graph->yaxis->scale->ticks->SupressMinorTickMarks(); // Supress minor ticks
		$graph->xaxis->SetTickLabels($datax);
		$graph->xaxis->SetTextLabelInterval(2);

		// if there are no points to be displyed, just give an error message
		if ($numres == 0)
		{
			$avgr[0] = 0;	//dummy value 
			
			// Create and add a new text
			$txt=new Text("No tests are conducted \n for the given period \n from this location.");
			$txt->Pos(0.5,0.5,"center","center");
			$txt->SetFont(FF_FONT2,FS_BOLD);
			$txt->ParagraphAlign('cenetered');
			$txt->SetBox('yellow','navy','gray');
			$txt->SetColor("red");
			$graph->AddText($txt);
		}

		// Create the linear plot 
		$lineplot=new LinePlot($avgr); 
		$lineplot->SetColor("blue"); 
		$lineplot->SetWeight(2);
	//	$lineplot->mark->SetType(MARK_UTRIANGLE);
	//	$lineplot->value->SetColor("darkred");

		// Add the plot to the graph 
		$graph->Add($lineplot); 
		// Display the graph 
		$graph->Stroke();
	} // end if type==tra
	

//=============== display results for a page =================================//
	if ($type == 'PG') // display result of page
	{
		// three dimensional array for holding result values
		// ResArr[i][j][0] stores cumulative response time for page i, for the time interval j
		// ResArr[i][j][1] stores number of samples for page i, for the time interval j
		// the division will give us the average response time
		$ResArr[0][0][0] = 0;
		
		// average response time
		$avgr[0][0] = 0;
		
		// initialize the array 
		for($init=0; $init <= $sample_point; $init++)
		{
			for ($init2=0; $init2<$numstep;$init2++)
			{
				$ResArr[$init2][$init][0] = 0;		// response time
				$ResArr[$init2][$init][1] = 0;		// number of samples
				$avgr[$init2][$init] = 0;	// average response time
			} // end for init2
		} // end for init

		// select results for given day and location 
		
		if (strncmp($location,"All",3) == 0) 	// select results from all locactions
		{

		$respg_q = "SELECT UNIX_TIMESTAMP(TrStart) as ts, StepNum, PgResponse FROM TrPageRes WHERE JobID ='".$jobid."' AND PgErr < 1 AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$todayts." AND ".($todayts + 24*60*60)." ;";

		}
		else 	// select result from specified location
		{

		$respg_q = "SELECT UNIX_TIMESTAMP(TrStart) as ts, StepNum, PgResponse FROM TrPageRes, DelegateInfo  WHERE JobID ='".$jobid."' AND TrPageRes.DelID = DelegateInfo.DelID AND DelegateInfo.DReg='".$location."' AND PgErr < 1 AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$todayts." AND ".($todayts + 24*60*60)." ;";

		}

		// echo $respg_q;
		$res	= mysql_query($respg_q) or die("Unable to execute query : respg_q ");
		
		// number of tests conducted is equal to number of results returned
		$numres = mysql_num_rows($res);

		while ($row = mysql_fetch_assoc($res))
		{
			$timest 	= $row['ts'];
			$resptime	= $row['PgResponse'];
			$stnum		= $row['StepNum'];
		
			// calculate the array index for this result 
			$ind	= floor(((($timest - $todayts)/60) + ($interval_min/2)) / ($interval_min));  

		//	echo $ind."\t\t".$stnum."\n\n";

			if (($ind <= $sample_point) && ($stnum <=$numstep)) // the index is within range and stepnumber is valid
			{
				// add response time for this test
				$ResArr[$stnum-1][$ind][0] += $resptime;	

				// number of tests increased by 1  - this will be used to calculate avg. response time	
				$ResArr[$stnum-1][$ind][1] += 1;		

			}
		}

		/* Free resultset */
		
		mysql_free_result($res);     
		mysql_close($dbconn);	/* Closing connection */

		// calculate average 
		for ($ind = 0; $ind <= $sample_point; $ind++)
		for ($init2=0; $init2<$numstep;$init2++)
		{
			if ($ResArr[$init2][$ind][1] > 0)
			{
				$avgr[$init2][$ind] = ceil($ResArr[$init2][$ind][0] / $ResArr[$init2][$ind][1]);
				
		/*		echo $ind."\t";
				echo $ResArr[$init2][$ind][0]."\t";
				echo $ResArr[$init2][$ind][1]."\t";
				echo $avgr[$init2][$ind]."\n";
		*/	
			
			}
			else  // if there is no data, it will be treated as null value
			{
				$avgr[$init2][$ind] = "-";	
			}
		}

		include("jpgraph/jpgraph.php");
		include("jpgraph/jpgraph_line.php");

		$datax = array(0); // text labels for x-axis

		$step = ($sample_point > 24 ? 0.5:1);

		// create scale for x-axis
		for ($ind=1;$ind<= $sample_point; $ind++)
		{
			$datax[$ind] = $datax[$ind-1] + $step;
		}

		// Create the graph. These two calls are always required 
		$graph = new Graph(700,500); 
		$graph->SetScale("textlin"); 


		// Setup margin and titles 
		$graph->img->SetMargin(60,20,20,60); 
		$graph->SetMarginColor("antiquewhite");
		$graph->title->Set(date("M d Y",$todayts)); // date is the title 
		$graph->yaxis->SetTitlemargin(45);
		$graph->xaxis->title->Set("Hour of Day"); 
		$graph->yaxis->title->Set("Response Time in millisecond");
		$graph->yaxis->scale->SetGrace(10,0); 	// Make some room at top and bottom of graph	

		// Set footer 
		$str = "Generated at  ".gmdate("M d Y H:i:s", time())." GMT ";
		$graph->footer->right->Set($str);
		$graph->footer->center->Set("(C) CSE, IIT Kanpur ");

		// set legend position and direction
		$graph->legend->Pos(0.05,0.98,"left","bottom");
		$graph->legend->SetLayout(LEGEND_HOR);
		$graph->legend->SetLineWeight(2);

		// Nice shadow
		$graph->SetColor('ivory');
		$graph->SetShadow();

		// show  grid 
		$graph->xgrid->Show();

		//$graph->yaxis->scale->ticks->Set(500,500); // Set major and minor tick to 500
		$graph->yaxis->scale->ticks->SupressMinorTickMarks(); // Supress minor ticks
		$graph->xaxis->SetTickLabels($datax);
		$graph->xaxis->SetTextLabelInterval(2);


		for($ind=0; $ind<$numstep; $ind++)
		{
			// if there are no points to be displyed, just give an error message
			if ($numres == 0)
			{
				$avgr[$ind][0] = 0;	//dummy value 
				
				// Create and add a new text
				$txt=new Text("No tests are conducted \n for the given period \n from this location.");
				$txt->Pos(0.5,0.5,"center","center");
				$txt->SetFont(FF_FONT2,FS_BOLD);
				$txt->ParagraphAlign('cenetered');
				$txt->SetBox('yellow','navy','gray');
				$txt->SetColor("red");
				$graph->AddText($txt);
			}

			// Create the linear plot 
			$lineplot[$ind]=new LinePlot($avgr[$ind]); 
			// $lineplot[$ind]->mark->SetType(MARK_UTRIANGLE);
			
			switch ($ind)
			{
				case 0:
					$lineplot[$ind]->SetColor("blue"); 
					$lineplot[$ind]->SetWeight(2);
					$lineplot[$ind]->SetLegend("Step 1");
					break;

				case 1:
					$lineplot[$ind]->SetColor("maroon"); 
					$lineplot[$ind]->SetWeight(2);
					$lineplot[$ind]->SetLegend("Step 2");
					break;

				case 2:
					$lineplot[$ind]->SetColor("purple3"); 
					$lineplot[$ind]->SetWeight(2);
					$lineplot[$ind]->SetLegend("Step 3");
					break;

			}
			// Add the plot to the graph 
			$graph->Add($lineplot[$ind]); 
		} // end for
		// Display the graph 
		$graph->Stroke();

	} //end if type==pg

?>
