<?php

/*	Generating the graph of Throughput for required Transaction
 *	The graph can be either for complete transaction or individual step of transaction
 *
 *	THIS CODE IS VERY SIMILAR TO thr.php
 *	The ONLY difference is we are plotting DIFFERENT GRAPHS for EACH LOCATION. 
 */	

	// add http header to make sure that the response is not cached
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 

	$jobid	= $_GET['jid'];	// Job ID
	$type  = $_GET['type'];	// Type of result - PG for pagewise result and TRA for transaction
	$loctmp = $_GET['loc']; // locations of delegate - it wil be something like "loc1,loc2,loc3,"
	
	// start day of result
	$stday	= $_GET['std']; // day
	$stmon	= $_GET['stm']; // month
	$styr	= $_GET['sty']; // year
	$day1 = strtotime($styr."-".$stmon."-".$stday."-");	// timestamp for starting day

	// duration for which result is to be shown
	// 1 : show result only for one day
	// 2 : show result for specified interval 
	$dur 	= $_GET['dur'];	

	if ($dur == 2) 
	{
		// end day of result
		$enday	= $_GET['end'];	// day
		$enmon	= $_GET['enm'];	// month
		$enyr	= $_GET['eny'];	// year
		$day2 = strtotime($enyr."-".$enmon."-".$enday."-");	// timestamp for ending day
	}
	else	// show result for a single day 
	{
		// create timestamp for next day
		$day2 = $day1 + 24*60*60; 
	}

	$diff = ($day2-$day1)/(24*60*60); // difference in number of days

	if ($diff > 7) // if the difference between days is greater than 7 days, give error message
	{
		exit();	
	}

	// calculate values for interval 
	switch ($diff)
	{
		case 1:
			$interval_min = 60; // interval to be used in graph. 
			$sample_point = 24; // number of points on x-axis 
			break;
		case 2: 
			$interval_min = 120;
			$sample_point = 24; 
			break;
		case 3: 
			$interval_min = 180;
			$sample_point = 24; 
			break;
		case 4: 
			$interval_min = 240;
			$sample_point = 24; 
			break;
		case 5: 
			$interval_min = 360;
			$sample_point = 20; 
			break;
		case 6: 
			$interval_min = 360;
			$sample_point = 24; 
			break;
		case 7: 
			$interval_min = 360;
			$sample_point = 28; 
			break;
	}

	// the character comma (",") acts as delimiter for the string of locations
	$delim = ",";

	// remove the trailing "," 
	$loctmp = trim($loctmp , $delim );

	// get all the locations in the array 
	$location = explode($delim, $loctmp);

	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("Unable to connect to server."); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("Unable to select database.");

/*	$interval_q = "SELECT NumStep , PPHLoad FROM JobInfo WHERE JobID ='".$jobid."'"; 

	$dbconn = mysql_connect("server_name", "user_name", "password" ) or die("Unable to connect to server."); 
	$result = mysql_select_db("databse_name", $dbconn)  or die ("Unable to select database.");
	
	$res_int = mysql_query($interval_q) or die("Unable to execute query");
	$int_row = mysql_fetch_assoc($res_int);

	$numstep = $int_row['NumStep'];	// get number of steps in transaction
	
	// if  pphload / numstep > 1.5 , set interval_min = 30
	if ( 2 * $int_row['PPHLoad'] > 3*$int_row['NumStep'])
	{
		$interval_min = 30;
		$sample_point = 48;
	}

	mysql_free_result($res_int);
*/
	if ($type != 'TRA') // if type is not TRA, exit
	{
		exit();
	}


//=============== display results for a transaction =================================//

	// *** create empty canvas for graph 
	$datax = array(0); // text labels for x-axis

	// if the results are to be displayed for a period of time, add date in x-scale
	if ($dur == 2) 
	{
		$step	= $interval_min / 60;	// calculate number of hours to be used as step
		$dy	= $day1;		// timestamp for first day
		$hr	= 0; 			// start hour 
		
		// create scale for x-axis
		for ($ind=0;$ind<= $sample_point; $ind++)
		{

			$datax[$ind] = date("Y:M:d",$dy)." ".$hr." Hrs "; // text labels for x-axis

			$hr += $step;	// find next label 
			$hr %=24;
			$dy += $interval_min * 60; // update timestamp
		}
	}

	// if results are for a day, display hour of day
	if ($dur == 1)
	{
		$step = ($sample_point > 24 ? 0.5:1);

		// create scale for x-axis
		for ($ind=1;$ind<= $sample_point; $ind++)
		{
			$datax[$ind] = $datax[$ind-1] + $step;
		}
	}

	include("jpgraph/jpgraph.php");
	include("jpgraph/jpgraph_line.php");

	// Create the graph. These two calls are always required 
	$graph = new Graph(700,500); 
	$graph->SetScale("textlin"); 

	// colors used for different line plots
	$linecol = array('darkorchid','coral','firebrick1','magenta4','cyan'); 
	$linest  = array('solid', 'dashed', 'dotted', 'solid', 'dotted');

	$numloc = 0;

	while ($numloc < count($location))
	{

		// two dimensional array for holding result values
		// first row holds the cumulative response time (in miliseconds )
		// and second row holds the cumulative data received (in bytes)
		// from these parameters throughput is calculated
		$ResArr[0][0] = 0;	
		
		// average throughput
		$avgr[0] = 0;	
		
		// initialize the array 
		for($init=0; $init <= $sample_point; $init++)
		{
			$ResArr[$init][0] = 0;	// response time
			$ResArr[$init][1] = 0;	// number of samples
			$avgr[$init] = 0;	// average response time
		}


		// select results for given day and location  which are not in error 
		
		$restr_q = "SELECT UNIX_TIMESTAMP(TrStart) as ts, PgResponse, PgSize FROM TrPageRes, DelegateInfo WHERE JobID ='".$jobid."'AND PgErr < 1 AND TrPageRes.DelID = DelegateInfo.DelID  AND DelegateInfo.DReg='".$location[$numloc]."' AND UNIX_TIMESTAMP(TrStart) BETWEEN  ".$day1." AND ".$day2." ;";

		$res	= mysql_query($restr_q) or die("Unable to execute query : restr_q");

		// number of tests conducted is equal to number of results returned
		$numres = mysql_num_rows($res);

		while ($row = mysql_fetch_assoc($res))
		{
			$timest 	= $row['ts'];
			$resptime	= $row['PgResponse'];
			$pgsize		= $row['PgSize'];
		
			// calculate the array index for this result 
			$ind	= floor( ((($timest - $day1)/60) + ($interval_min/2)) / ($interval_min));  

			if ($ind <= $sample_point)
			{
				$ResArr[$ind][0] += $resptime;	// add response time for this test
				$ResArr[$ind][1] += $pgsize;
			}
		}

		/* Free resultset */
		mysql_free_result($res);     

		// flag to check there is atleast one point on the result. 
		// flag = 1 means there exists atleast one point, flag =0 means otherwise
		$flag = 0;

		// calculate average
		for ($ind = 0; $ind <= $sample_point; $ind++)
		{
			if ($ResArr[$ind][1] > 0)
			{
				// find average throughput
				// throughput (bytes per second) = bytes received / time required in seconds
				// multiplication by 1000 because time is in millisecond
				$avgr[$ind] = ceil(($ResArr[$ind][1] / $ResArr[$ind][0])*1000); 
				$flag = 1; // there atleast one point in the graph
			}
			else  // if there is no data, it will be treated as null value
			{
				$avgr[$ind] = "-";	
			}
		}

		// if there is no point, insert a dummy value
		if ($flag == 0)
		{
			$avgr[0] = 0;	//dummy value 
		}

		// Create the linear plot for this location
		$lineplot[$numloc]=new LinePlot($avgr); 
		$lineplot[$numloc]->SetColor($linecol[$numloc]); 
		$lineplot[$numloc]->SetStyle($linest[$numloc]); 
		$lineplot[$numloc]->SetWeight(2);
		$lineplot[$numloc]->SetLegend($location[$numloc]);

		// Add the plot to the graph 
		$graph->Add($lineplot[$numloc]); 

		$numloc += 1;
	} // end while


	// Set footer 
	$str = "Generated at  ".gmdate("M d Y H:i:s", time())." GMT ";
	$graph->footer->right->Set($str);
	$graph->footer->center->Set("(C) CSE, IIT Kanpur ");

	// Nice shadow and color
	$graph->SetShadow();
	$graph->SetColor('ivory');

	// Show  grid in background
	$graph->xgrid->Show();

	// Setup margin and titles 
	if ($dur == 1)
	{
		$graph->img->SetMargin(60,20,20,60); 
		$graph->xaxis->title->Set("Hour of Day"); 
		$graph->title->Set(date("M d Y",$day1)); // date is the title 
	}
	if ($dur == 2)
	{
		$graph->img->SetMargin(60,20,20,150); 
		// $graph->xaxis->title->Set("Date and Time"); 
		$titlestr = date("M d, Y", $day1)." -TO- ".date("M d, Y", $day2);
		$graph->title->Set($titlestr); // date is the title 
		// results are for a period more than 1 day, display scale at 90 degrees 
		$graph->xaxis->SetLabelAngle(90);
	}
	$graph->SetMarginColor("antiquewhite");

	// set legend position and direction
	$graph->legend->Pos(0.05,0.98,"left","bottom");
	$graph->legend->SetLayout(LEGEND_HOR);
	$graph->legend->SetLineWeight(2);

	$graph->yaxis->SetTitlemargin(45);
	$graph->yaxis->scale->SetGrace(10,0); 	// Make some room at top and bottom of graph	
	$graph->yaxis->title->Set("Throughput in Bytes per Second");

	$graph->yaxis->scale->ticks->SupressMinorTickMarks(); // Supress minor ticks
	$graph->xaxis->SetTickLabels($datax);
	$graph->xaxis->SetTextLabelInterval(2);
	
	// Display the graph 
	$graph->Stroke();
	mysql_close($dbconn);	/* Closing connection */

?>
